OCCT-计算二维图形的中轴线

2024-08-31 09:52

本文主要是介绍OCCT-计算二维图形的中轴线,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

方案一:三角剖分、重心的连接

// 获取TopoDS_Shape中所有三角形的重心并连接成中轴线
TopoDS_Shape GetTriangleCentroids(const TopoDS_Shape& shape)
{std::vector<gp_Pnt> points;TopExp_Explorer explorer(shape, TopAbs_FACE);while (explorer.More()){const TopoDS_Face& face = TopoDS::Face(explorer.Current());CalculateTriangleCentroid(points,face);explorer.Next();}// 使用BRepBuilderAPI_MakePolygon类构造PolylineBRepBuilderAPI_MakePolygon makePolygon;TColgp_Array1OfPnt PointsArray(1, points.size());int i = 0;for (auto & onept:points){makePolygon.Add(onept);PointsArray.SetValue(++i, onept);}// 获取构造的Polyline对象if (makePolygon.IsDone()){return makePolygon.Shape();}{Standard_Integer Dmin = 3;Standard_Integer Dmax = 8;Standard_Real Tol3d = 1.e-3;Handle(Geom_BSplineCurve) TheCurve;GeomAPI_PointsToBSpline aPointToBSpline(PointsArray);TheCurve = aPointToBSpline.Curve();// 创建一个AIS_Shape对象TopoDS_Shape TheCurveShape = BRepBuilderAPI_MakeEdge(TheCurve);return TheCurveShape;}return makePolygon.Edge();}
// 计算三角形的重心
void CalculateTriangleCentroid(std::vector<gp_Pnt> &points,const TopoDS_Face& face)
{TopLoc_Location loc;Handle(Poly_Triangulation) triangulation = BRep_Tool::Triangulation(face, loc);const Poly_Array1OfTriangle& triangles = triangulation->Triangles();for (size_t i = 1; i <= triangles.Size(); i++){const Poly_Triangle& triangle = triangles(i); // 假设只有一个三角形const gp_Pnt& p1 = triangulation->Node(triangle.Value(1));const gp_Pnt& p2 = triangulation->Node(triangle.Value(2));const gp_Pnt& p3 = triangulation->Node(triangle.Value(3));// 计算三个顶点的坐标平均值gp_Pnt centroid((p1.X() + p2.X() + p3.X()) / 3.0,(p1.Y() + p2.Y() + p3.Y()) / 3.0,(p1.Z() + p2.Z() + p3.Z()) / 3.0);points.emplace_back(centroid);}
}

方案二:曲线连续性

// 定义一个函数,用于提取曲线的中轴线
TopoDS_Shape ExtractCurveAxis(const Handle(Geom_Curve)& curve)
{int numPoints = 3;// 创建一个GeomLProp_CLProps对象,并将待提取中轴线的曲线作为参数传入GeomLProp_CLProps props(curve,1,1e-6);// 调用GeomLProp_CLProps类的SetParameter函数,设置参数,如精度等props.SetParameter(1e-6);// 调用GeomLProp_CLProps类的Curvature函数,获取曲线上每个点的曲率信息std::vector<Standard_Real> curvatures;for (Standard_Integer i = 1; i <= numPoints; i++) {Standard_Real u = curve->FirstParameter() + (i - 1) * (curve->LastParameter() - curve->FirstParameter()) / (numPoints - 1);props.SetParameter(u);Standard_Real curvature = props.Curvature();curvatures.push_back(curvature);}// 调用GeomLProp_CLProps类的D1函数,获取曲线上每个点的一阶导数信息std::vector<gp_Vec> derivatives;for (Standard_Integer i = 1; i <= numPoints; i++){Standard_Real u = curve->FirstParameter() + (i - 1) * (curve->LastParameter() - curve->FirstParameter()) / (numPoints - 1);props.SetParameter(u);gp_Vec derivative=props.D1();derivatives.push_back(derivative);}// 根据曲率和一阶导数信息,计算中轴线的方向和位置std::vector<gp_Pnt> axisPoints;for (Standard_Integer i = 0; i < numPoints; i++){Standard_Real u = curve->FirstParameter() + i * (curve->LastParameter() - curve->FirstParameter()) / (numPoints - 1);gp_Pnt point = curve->Value(u);gp_Vec derivative = derivatives[i];Standard_Real curvature = curvatures[i];gp_Vec axisDirection = derivative.Normalized().Crossed(gp_Vec(0, 0, 1));gp_Pnt axisPoint = point.Translated(axisDirection.Multiplied(-curvature));axisPoints.push_back(axisPoint);}// 使用BRepBuilderAPI_MakePolygon类构造PolylineBRepBuilderAPI_MakePolygon makePolygon;TColgp_Array1OfPnt PointsArray(1, axisPoints.size());int i = 0;for (auto& onept : axisPoints){makePolygon.Add(onept);PointsArray.SetValue(++i, onept);}// 获取构造的Polyline对象if (makePolygon.IsDone()){//return makePolygon.Shape();}// 根据计算得到的中轴线信息,创建一个Handle(Geom_Curve)对象//  Handle(Geom_BSplineCurve) axisCurve = new Geom_BSplineCurve(axisPoints.data(), numPoints, degree, GeomAbs_C2, knots, multiplicities, weights);// Make a BSpline curve from the points array.TColgp_Array1OfPnt aPoles(1, axisPoints.size());int nNo = 0;for (auto& pt : axisPoints){aPoles.SetValue(++nNo, pt);}Handle(Geom_BSplineCurve) aBSplineCurve = GeomAPI_PointsToBSpline(aPoles).Curve();{// 将Geom_BSplineCurve对象转换为可视化对象TopoDS_Shape BSplineShape = BRepBuilderAPI_MakeEdge(aBSplineCurve);return BSplineShape;}
}

这篇关于OCCT-计算二维图形的中轴线的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1123571

相关文章

【前端学习】AntV G6-08 深入图形与图形分组、自定义节点、节点动画(下)

【课程链接】 AntV G6:深入图形与图形分组、自定义节点、节点动画(下)_哔哩哔哩_bilibili 本章十吾老师讲解了一个复杂的自定义节点中,应该怎样去计算和绘制图形,如何给一个图形制作不间断的动画,以及在鼠标事件之后产生动画。(有点难,需要好好理解) <!DOCTYPE html><html><head><meta charset="UTF-8"><title>06

poj2576(二维背包)

题意:n个人分成两组,两组人数只差小于1 , 并且体重只差最小 对于人数要求恰好装满,对于体重要求尽量多,一开始没做出来,看了下解题,按照自己的感觉写,然后a了 状态转移方程:dp[i][j] = max(dp[i][j],dp[i-1][j-c[k]]+c[k]);其中i表示人数,j表示背包容量,k表示输入的体重的 代码如下: #include<iostream>#include<

hdu2159(二维背包)

这是我的第一道二维背包题,没想到自己一下子就A了,但是代码写的比较乱,下面的代码是我有重新修改的 状态转移:dp[i][j] = max(dp[i][j], dp[i-1][j-c[z]]+v[z]); 其中dp[i][j]表示,打了i个怪物,消耗j的耐力值,所得到的最大经验值 代码如下: #include<iostream>#include<algorithm>#include<

poj 1113 凸包+简单几何计算

题意: 给N个平面上的点,现在要在离点外L米处建城墙,使得城墙把所有点都包含进去且城墙的长度最短。 解析: 韬哥出的某次训练赛上A出的第一道计算几何,算是大水题吧。 用convexhull算法把凸包求出来,然后加加减减就A了。 计算见下图: 好久没玩画图了啊好开心。 代码: #include <iostream>#include <cstdio>#inclu

uva 1342 欧拉定理(计算几何模板)

题意: 给几个点,把这几个点用直线连起来,求这些直线把平面分成了几个。 解析: 欧拉定理: 顶点数 + 面数 - 边数= 2。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

uva 11178 计算集合模板题

题意: 求三角形行三个角三等分点射线交出的内三角形坐标。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <

XTU 1237 计算几何

题面: Magic Triangle Problem Description: Huangriq is a respectful acmer in ACM team of XTU because he brought the best place in regional contest in history of XTU. Huangriq works in a big compa

HDU 2159 二维完全背包

FATE 最近xhd正在玩一款叫做FATE的游戏,为了得到极品装备,xhd在不停的杀怪做任务。久而久之xhd开始对杀怪产生的厌恶感,但又不得不通过杀怪来升完这最后一级。现在的问题是,xhd升掉最后一级还需n的经验值,xhd还留有m的忍耐度,每杀一个怪xhd会得到相应的经验,并减掉相应的忍耐度。当忍耐度降到0或者0以下时,xhd就不会玩这游戏。xhd还说了他最多只杀s只怪。请问他能

音视频入门基础:WAV专题(10)——FFmpeg源码中计算WAV音频文件每个packet的pts、dts的实现

一、引言 从文章《音视频入门基础:WAV专题(6)——通过FFprobe显示WAV音频文件每个数据包的信息》中我们可以知道,通过FFprobe命令可以打印WAV音频文件每个packet(也称为数据包或多媒体包)的信息,这些信息包含该packet的pts、dts: 打印出来的“pts”实际是AVPacket结构体中的成员变量pts,是以AVStream->time_base为单位的显

计算数组的斜率,偏移,R2

模拟Excel中的R2的计算。         public bool fnCheckRear_R2(List<double[]> lRear, int iMinRear, int iMaxRear, ref double dR2)         {             bool bResult = true;             int n = 0;             dou